# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ManagedApplications::Mgmt::V2016_09_01_preview
  module Models
    #
    # Information about appliance definition.
    #
    class ApplianceDefinition < GenericResource

      include MsRestAzure

      # @return [ApplianceLockLevel] The appliance lock level. Possible values
      # include: 'CanNotDelete', 'ReadOnly', 'None'
      attr_accessor :lock_level

      # @return [String] The appliance definition display name.
      attr_accessor :display_name

      # @return [Array<ApplianceProviderAuthorization>] The appliance provider
      # authorizations.
      attr_accessor :authorizations

      # @return [Array<ApplianceArtifact>] The collection of appliance
      # artifacts. The portal will use the files specified as artifacts to
      # construct the user experience of creating an appliance from an
      # appliance definition.
      attr_accessor :artifacts

      # @return [String] The appliance definition description.
      attr_accessor :description

      # @return [String] The appliance definition package file Uri.
      attr_accessor :package_file_uri


      #
      # Mapper for ApplianceDefinition class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplianceDefinition',
          type: {
            name: 'Composite',
            class_name: 'ApplianceDefinition',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              managed_by: {
                client_side_validation: true,
                required: false,
                serialized_name: 'managedBy',
                type: {
                  name: 'String'
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'Identity'
                }
              },
              lock_level: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.lockLevel',
                type: {
                  name: 'Enum',
                  module: 'ApplianceLockLevel'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              authorizations: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.authorizations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplianceProviderAuthorizationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplianceProviderAuthorization'
                      }
                  }
                }
              },
              artifacts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.artifacts',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplianceArtifactElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplianceArtifact'
                      }
                  }
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              package_file_uri: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.packageFileUri',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
